


//+------------------------------------------------------------------+
//|                                                     sell&buy.mq4 |
//+------------------------------------------------------------------+

extern bool    RelaxedEntry   = false;
extern bool    UseMaxTrade  = true,
               OppositeSignalExit = true;
extern int     MaxOrderPerTrade  = 3;
extern double lots=0.05;
extern double target=1000000;

extern int    CandleShift = 0;

extern bool   Martingale=true;//|-----------------martingale
extern double Multiplier=1.1;//|-----------------multiplier martingale

extern string S1="---------------- Entry Settings";

extern int period=80; 
extern int method=3; // MODE_SMA 
extern int price=0;

extern bool     UseTradeTime1     = false;
extern int      TradeStartHour1   = 0;
extern int      TradeStartMinute1 = 0;
extern int      TradeStopHour1    = 6;
extern int      TradeStopMinute1  = 0;

extern bool     UseTradeTime2     = false;
extern int      TradeStartHour2   = 8;
extern int      TradeStartMinute2 = 0;
extern int      TradeStopHour2    = 12;
extern int      TradeStopMinute2  = 0;

extern bool     UseTradeTime3     = false;
extern int      TradeStartHour3   = 16;
extern int      TradeStartMinute3 = 0;
extern int      TradeStopHour3    = 22;
extern int      TradeStopMinute3  = 0;

int cbars=0;
int magic=9348670;
int dist=24,decimlot;

int init()
{
   if(MarketInfo(Symbol(), MODE_MINLOT)==0.001)decimlot = 3;
   if(MarketInfo(Symbol(), MODE_MINLOT)==0.01) decimlot = 2;
   if(MarketInfo(Symbol(), MODE_MINLOT)==0.1)  decimlot = 1;
   if(MarketInfo(Symbol(), MODE_MINLOT)==1.0)  decimlot = 0;
      
      return(0);
}


int start() {

 bool IsTrade = false;
      
      if(UseTradeTime1)
      {
        if((TimeHour(Time[0]) == TradeStartHour1 && TimeMinute(TimeCurrent()) >= TradeStartMinute1) || (TimeHour(Time[0]) > TradeStartHour1))
        {
          if((TimeHour(Time[0]) == TradeStopHour1 && TimeMinute(TimeCurrent()) <= TradeStopMinute1) || (TimeHour(Time[0]) < TradeStopHour1))
          {
            IsTrade = true;
          }
        }
      }else IsTrade = true;
      
      
      if(UseTradeTime2)
      {
        if((TimeHour(Time[0]) == TradeStartHour2 && TimeMinute(TimeCurrent()) >= TradeStartMinute2) || (TimeHour(Time[0]) > TradeStartHour2))
        {
          if((TimeHour(Time[0]) == TradeStopHour2 && TimeMinute(TimeCurrent()) <= TradeStopMinute2) || (TimeHour(Time[0]) < TradeStopHour2))
          {
            IsTrade = true;
          }
        }
      }else IsTrade = true;
      
       if(UseTradeTime3)
      {
        if((TimeHour(Time[0]) == TradeStartHour3 && TimeMinute(TimeCurrent()) >= TradeStartMinute3) || (TimeHour(Time[0]) > TradeStartHour3))
        {
          if((TimeHour(Time[0]) == TradeStopHour3 && TimeMinute(TimeCurrent()) <= TradeStopMinute3) || (TimeHour(Time[0]) < TradeStopHour3))
          {
            IsTrade = true;
          }
        }
      }else IsTrade = true;

 double profit=0, Lot = lots;
 int j=OrdersTotal()-1;
 for (int i=j;i>=0;i--)
  {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
   if(OrderMagicNumber()==magic && OrderSymbol()==Symbol())
   profit=OrderProfit()+OrderSwap()+profit;
  }
 
 if (profit>=target)
  {
   j=OrdersTotal()-1;
   for (i=j;i>=0;i--)
    {
     OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
     RefreshRates();
     if(OrderType()==OP_BUY && OrderMagicNumber()==magic && OrderSymbol()==Symbol())
      OrderClose(OrderTicket(),OrderLots(),Bid,3,Blue);
    }
  }
 
 double sig = Lowest(NULL,0,MODE_LOW,dist,0);
 
 double SDL2=iCustom(Symbol(),0,"Slope Direction Line",period,method,price,0);
 double SDL4=iCustom(Symbol(),0,"Slope Direction Line",period,method,price,1);
 
 double SDL2_2=iCustom(Symbol(),0,"Slope Direction Line",period,method,price,0);
 double SDL4_2=iCustom(Symbol(),0,"Slope Direction Line",period,method,price,2);
 
      int limit=1,buy=0,sell=0;
      for(int f=1;f<=CandleShift;f++)
      {
        double SDL1=iCustom(Symbol(),0,"Slope Direction Line",period,method,price,0,f);
        double SDL3=iCustom(Symbol(),0,"Slope Direction Line",period,method,price,1,f);
        
        if(SDL1>0&&SDL1!=EMPTY_VALUE)buy++;
        
        if(SDL3>0&&SDL3!=EMPTY_VALUE)sell++;
      }
      bool BUY=false;
      bool SELL=false;

      if(((RelaxedEntry && SDL2>0&&SDL2!=EMPTY_VALUE && ((SDL4_2 == SDL2_2) || (SDL4_2 != EMPTY_VALUE && SDL2_2 == EMPTY_VALUE)) && SDL4 == EMPTY_VALUE) || (!RelaxedEntry && SDL2>0&&SDL2!=EMPTY_VALUE && SDL4 == EMPTY_VALUE)) && buy >= CandleShift){BUY=true;if(OppositeSignalExit)closesell();}
      if(((RelaxedEntry && SDL4>0&&SDL4!=EMPTY_VALUE && ((SDL2_2 == SDL4_2) || (SDL2_2 != EMPTY_VALUE && SDL4_2 == EMPTY_VALUE)) && SDL2 == EMPTY_VALUE) || (!RelaxedEntry && SDL4>0&&SDL4!=EMPTY_VALUE && SDL2 == EMPTY_VALUE)) && sell >= CandleShift){SELL=true;if(OppositeSignalExit)closebuy();}
 
 if(cbars!=Bars && BUY && IsTrade && ((count(OP_BUY)< MaxOrderPerTrade && UseMaxTrade )|| (!UseMaxTrade)))
  {
   RefreshRates();
   
   double lastblot=LastLot(OP_BUY);         
   if(lastblot>0 && Martingale)Lot = NormalizeDouble(lastblot * Multiplier,decimlot); 
   else Lot = lots;
   
   OrderSend(Symbol(),OP_BUY,Lot,Ask,3,0,0,"buy",magic,0,Blue);
   string AN="ArrBuy "+TimeToStr(CurTime());
   ObjectCreate(AN,OBJ_ARROW,0,Time[1],Low[1]-6*Point,0,0,0,0);
   ObjectSet(AN, OBJPROP_ARROWCODE, 233);
   ObjectSet(AN, OBJPROP_COLOR , Blue);
  }

 profit=0;
 j=OrdersTotal()-1;
 for (i=j;i>=0;i--)
  {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
   if(OrderType()==OP_SELL && OrderMagicNumber()==magic && OrderSymbol()==Symbol())
   profit=OrderProfit()+OrderSwap()+profit;
  }
 
 if (profit>=target)
  {
   j=OrdersTotal()-1;
   for (i=j;i>=0;i--)
    {
     OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
     RefreshRates();       
     if(OrderType()==OP_SELL && OrderMagicNumber()==magic && OrderSymbol()==Symbol())
      OrderClose(OrderTicket(),OrderLots(),Ask,3,Magenta);
    }
  }
 
 sig = Highest(NULL,0,MODE_HIGH,dist,0);
 if(cbars!=Bars && SELL && IsTrade && ((count(OP_SELL)< MaxOrderPerTrade && UseMaxTrade )|| (!UseMaxTrade)))
  {
   RefreshRates();
   double lastslot=LastLot(OP_SELL);         
   if(lastslot>0 && Martingale)Lot = NormalizeDouble(lastslot * Multiplier,decimlot); 
   else Lot = lots;
   OrderSend(Symbol(),OP_SELL,Lot,Bid,3,0,0,"sell",magic,0,Magenta);
   AN="ArrSell "+TimeToStr(CurTime());
   ObjectCreate(AN,OBJ_ARROW,0,Time[1],High[1]+6*Point,0,0,0,0);
   ObjectSet(AN, OBJPROP_ARROWCODE, 234);
   ObjectSet(AN, OBJPROP_COLOR , Magenta);
  }

 cbars=Bars;
 
 return(0);
}

double LastLot(int type)
{
  int total=OrdersTotal();
  for(int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==type)
      {
        return(OrderLots());
      }
    }
  }
  return(0);
}

void closesell()
 {
   if (OrdersTotal() > 0) 
   {
      for (int total = OrdersTotal(); total >= 0; total--)
       {
         OrderSelect(total, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == magic && OrderType() == OP_SELL)
         {
          OrderClose(OrderTicket(), OrderLots(), Ask, 3, Red);
         }
      }
   }
}

void closebuy()
 {
  if (OrdersTotal() > 0) 
   {
    for (int total = OrdersTotal(); total >= 0; total--)
       {
         OrderSelect(total, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == magic && OrderType() == OP_BUY)
         {
          OrderClose(OrderTicket(), OrderLots(), Bid, 3, Red);
         }
      }
   }
}

int count(int type)
{
 int ntotal=OrdersTotal();
 int ncnt,nOpenTradesOnSymbol=0;
 for(ncnt=0;ncnt<ntotal;ncnt++)
   {
     OrderSelect(ncnt, SELECT_BY_POS, MODE_TRADES);
     if (OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==type)
     nOpenTradesOnSymbol++; 
   } 
  return(nOpenTradesOnSymbol);
}